<template>
  <div id="app">
    <sidebar />

    <b-navbar>
      <template slot="brand">
        <flag-select />
        <b-navbar-item tag="router-link" :to="{ path: '/' }">
          <span class="first-letter-colored">KadoKadeo</span>
        </b-navbar-item>
      </template>

      <template v-if="$store.getters.isLogged">
        <template slot="start">
          <menu-item v-for="link in menuLinks" :key="link.path"
                    :path="link.path"
                    :label="link.label"
                    :labelKey="link.labelKey"
                    :icon="link.icon" />
        </template>

        <template slot="end">
          <b-navbar-item>
            <b-button @click="logOut" type="is-primary">
              <b-icon icon="power-off" />
            </b-button>
          </b-navbar-item>
        </template>
      </template>
    </b-navbar>

    <router-view :key="$route.path" class="view" />
  </div>
</template>


<script lang="ts">
import { Component, Vue } from 'vue-property-decorator';
import { first } from 'lodash';

import MenuItem from '@/components/MenuItem.vue';
import FlagSelect from '@/components/FlagSelect.vue';
import Sidebar from '@/components/layout/Sidebar.vue';
import { USER, AUTH } from '@/store';

interface MenuLink {
  label?: () => string;
  labelKey?: string;
  icon: string;
  path: string;
}

@Component({
  components: { MenuItem, FlagSelect, Sidebar },
})
export default class App extends Vue {
  menuLinks: MenuLink[] = [
    {
      label: this.displayedName,
      icon: 'user',
      path: '/me',
    },
    {
      labelKey: 'menu.games',
      icon: 'gamepad',
      path: '/games',
    },
    {
      labelKey: 'menu.site',
      icon: 'trophy',
      path: '/site',
    },
    {
      labelKey: 'menu.clan',
      icon: 'users',
      path: '/clans',
    },
    {
      labelKey: 'menu.forum',
      icon: 'comments',
      path: '/forum',
    },
  ];

  logOut(): void {
    this.$cookie.delete('session');
    this.$store.commit(USER, null);
    this.$store.commit(AUTH, {});

    this.$router.push({ name: 'Auth' });
  }

  displayedName(): string {
    if (!this.$store.getters.isLogged)
      return '';

    return first(this.$store.getters.userEmail.split('@'));
  }
}
</script>

<style lang="scss">
$sidebar-width: 260px;

body {
  background:linear-gradient($white, lighten(#425F67, 52));
  min-height: 100vh;
}

#app {
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;

  .navbar {
    background: linear-gradient($black, $grey);
    border-bottom: 3px solid $primary;
    padding: 20px;
    margin-bottom: 10px;
    width: calc(100% - #{$sidebar-width});

    &-brand {
      font-size: 30px;
      a {
        margin: 0 25px;
        color: $white-ter;
      }
    }
  }

  .view {
    width: calc(100% - #{$sidebar-width});
    padding: 0 2rem;
  }

  .card {
    background-color: $white-bis;
  }

  h2.is-size-4 {
    margin-bottom: 1rem;
  }
}
</style>
